{#-#####################################################################
 # Helper macros common to all network frameworks
 #======================================================================
 # This file provides common Jinja macros which are required to generate
 # network configurations for any network framework.
 ####################################################################-#}
{#======================================================================
 # Normalize interface
 #----------------------------------------------------------------------
 # Normalize a single interface definition by merging it in top of
 # the skeleton data structure.
 #===================================================================-#}
{%- macro normalize_definition(interface, skeleton, defaults) -%}

  {#- Apply platform defaults on top of skeleton -#}
  {%- set normalized_defaults =
      skeleton | combine(defaults, recursive=true) -%}

  {#- Apply interface definition on top of normalized defaults -#}
  {%- set normalized_interface =
      normalized_defaults | combine(interface, recursive=true) -%}

  {#- Return normalized interface definition as a JSON string -#}
  {{ normalized_interface | to_json }}
{%- endmacro -%}

{#======================================================================
 # Validate interface
 #----------------------------------------------------------------------
 # Validates the structure of the supplied interface definition, then
 # returns validation results as a boolean.
 #===================================================================-#}
{%- macro validate_interface(interface) -%}
  {%- set validation_results = {
    "is_valid": true,
    "err_msgs": []
  } -%}

  {#--------------------------------------------------------------------
   # Common checks
   #------------------------------------------------------------------#}
  {#- All interfaces must have a non-empty 'uid' key -#}
  {%- if not interface['uid'] -%}
    {{ validation_results.err_msgs.append("Interface has no uid!") }}
    {#- Interface is now invalid -#}
    {{ validation_results.update({"is_valid": false}) }}
  {%- endif -%}

  {#--------------------------------------------------------------------
   # Specific checks for 'adapter' interfaces
   #------------------------------------------------------------------#}
  {%- if interface['type'] == 'adapter' -%}
    {#- Verify that a physical device is specified and exists -#}
    {%- if  interface['adapter']['device'] and
        not interface['adapter']['device'] in ansible_interfaces
    -%}
      {{ validation_results.err_msgs.append(
        "Interface " ~ interface['uid'] ~ ": bad device name") }}
      {#- Interface is now invalid -#}
      {{ validation_results.update({"is_valid": false}) }}
    {%- endif -%}

  {#--------------------------------------------------------------------
   # Specific checks for 'bond' interfaces
   #------------------------------------------------------------------#}
  {%- elif interface['type'] == 'bond' -%}

    {#- Validate bonding index -#}
    {%-   if interface['bond']['index'] is sameas None -%}
      {{ validation_results.err_msgs.append(
        "Interface " ~ interface['uid'] ~ ": missing bond index") }}
      {#- Interface is now invalid -#}
      {{ validation_results.update({"is_valid": false}) }}
    {%- elif interface['bond']['index'] | int < 0 -%}
      {{ validation_results.err_msgs.append(
        "Interface " ~ interface['uid'] ~ ": bond index < 0") }}
      {#- Interface is now invalid -#}
      {{ validation_results.update({"is_valid": false}) }}
    {%- elif interface['bond']['index'] | int > 2048 -%}
      {{ validation_results.err_msgs.append(
        "Interface " ~ interface['uid'] ~ ": bond index > 0") }}
      {#- Interface is now invalid -#}
      {{ validation_results.update({"is_valid": false}) }}
    {%- endif -%}

    {#- Validate hash policy -#}
    {%- if interface['bond']['hash_policy'] is not sameas None -%}
      {%- set hash_policies = ['layer2', 'layer23', 'layer3', 'layer34',
                               'layer4', 'encap23', 'encap34'] -%}
      {%- if not interface['bond']['hash_policy'] in hash_policies-%}
        {{ validation_results.err_msgs.append(
          "Interface " ~ interface['uid'] ~ ": invalid hash policy") }}
        {#- Interface is now invalid -#}
        {{ validation_results.update({"is_valid": false}) }}
      {%- endif -%}
    {%- endif -%}

    {#- Validate bonding mode -#}
    {%- if interface['bond']['mode'] is not sameas None -%}
      {%- set bonding_modes = ['broadcast', 'failover', 'hash', 'lacp',
                               'roundrobin', 'tlbd', 'tlbh', 'alb'] -%}
      {%- if not interface['bond']['mode'] in bonding_modes -%}
        {{ validation_results.err_msgs.append(
          "Interface " ~ interface['uid'] ~ ": invalid bonding mode")}}
        {#- Interface is now invalid -#}
        {{ validation_results.update({"is_valid": false}) }}
      {%- endif -%}
    {%- endif -%}

    {#- Validate bond slaves -#}
    {%- if not interface['bond']['slaves'] -%}
      {{ validation_results.err_msgs.append(
        "Interface " ~ interface['uid'] ~ ": missing bond slaves")}}
      {#- Interface is now invalid -#}
      {{ validation_results.update({"is_valid": false}) }}
    {%- elif interface['bond']['slaves'] is not iterable -%}
      {{ validation_results.err_msgs.append(
        "Interface " ~ interface['uid'] ~
        ": bond slaves is not a list") }}
      {#- Interface is now invalid -#}
      {{ validation_results.update({"is_valid": false}) }}
    {%- endif -%}

  {#--------------------------------------------------------------------
   # Specific checks for 'bridge' interfaces
   #------------------------------------------------------------------#}
  {%- elif interface['type'] == 'bridge' -%}

    {#- Validate bridge index -#}
    {%-   if interface['bridge']['index'] is sameas None -%}
      {{ validation_results.err_msgs.append(
        "Interface " ~ interface['uid'] ~ ": missing bridge index") }}
      {#- Interface is now invalid -#}
      {{ validation_results.update({"is_valid": false}) }}
    {%- elif interface['bridge']['index'] | int < 0 -%}
      {{ validation_results.err_msgs.append(
        "Interface " ~ interface['uid'] ~ ": bridge index < 0") }}
      {#- Interface is now invalid -#}
      {{ validation_results.update({"is_valid": false}) }}
    {%- elif interface['bridge']['index'] | int > 2048 -%}
      {{ validation_results.err_msgs.append(
        "Interface " ~ interface['uid'] ~ ": bridge index > 2048") }}
      {#- Interface is now invalid -#}
      {{ validation_results.update({"is_valid": false}) }}
    {%- endif -%}

    {#- Validate bridge members -#}
    {%- set bridge_members = interface['bridge']['members']-%}
    {%- if bridge_members is not iterable -%}
      {{ validation_results.err_msgs.append(
        "Interface " ~ interface['uid'] ~
        ": bridge members is not a list") }}
      {#- Interface is now invalid -#}
      {{ validation_results.update({"is_valid": false}) }}
    {%- endif -%}

    {#- STP options -#}
    {%- set stp = interface['bridge']['stp'] -%}
    {%- set idioms =
        role__sys_net_interfaces__platform_options['idioms'] -%}

    {#- STP forwarding delay -#}
    {%- if stp['fwd_delay'] is not sameas None -%}
      {%- if stp['fwd_delay'] | int <  idioms['stp_fwd_delay_min'] -%}
        {{ validation_results.err_msgs.append(
          "Interface " ~ interface['uid'] ~
          ": STP forwarding delay < " ~ idioms['stp_fwd_delay_min'] )}}
        {#- Interface is now invalid -#}
        {{ validation_results.update({"is_valid": false}) }}
      {%- elif stp['fwd_delay'] | int > idioms['stp_fwd_delay_max'] -%}
        {{ validation_results.err_msgs.append(
          "Interface " ~ interface['uid'] ~
          ": STP forwarding delay > " ~ idioms['stp_fwd_delay_max']) }}
        {#- Interface is now invalid -#}
        {{ validation_results.update({"is_valid": false}) }}
      {%- endif -%}
    {%- endif -%}

    {#- STP hello time delay -#}
    {%- if stp['hello_time'] is not sameas None -%}
      {%- if stp['hello_time'] | int < idioms['stp_fwd_hello_min'] -%}
        {{ validation_results.err_msgs.append(
          "Interface " ~ interface['uid'] ~
          ": STP hello time < " ~ idioms['stp_fwd_hello_min'] )}}
        {#- Interface is now invalid -#}
        {{ validation_results.update({"is_valid": false}) }}
      {%- elif stp['hello_time'] | int > idioms['stp_fwd_hello_max'] -%}
        {{ validation_results.err_msgs.append(
          "Interface " ~ interface['uid'] ~
          ": STP hello time > " ~ idioms['stp_fwd_hello_max']) }}
        {#- Interface is now invalid -#}
        {{ validation_results.update({"is_valid": false}) }}
      {%- endif -%}
    {%- endif -%}

    {#- STP priority -#}
    {%- if stp['priority'] is not sameas None -%}
      {%-   if stp['priority'] | int < idioms['stp_min_priority'] -%}
        {{
          validation_results.err_msgs.append(
            "Interface " ~ interface['uid'] ~
            ": STP priority < " ~ idioms['stp_min_priority'])
        }}
        {#- Interface is now invalid -#}
        {{ validation_results.update({"is_valid": false}) }}
      {%- elif stp['priority'] | int > idioms['stp_max_priority'] -%}
        {{
          validation_results.err_msgs.append(
            "Interface " ~ interface['uid'] ~
            ": STP priority > " ~ idioms['stp_max_priority'])
          }}
        {#- Interface is now invalid -#}
        {{ validation_results.update({"is_valid": false}) }}
      {%- endif -%}
    {%- endif -%}

  {#--------------------------------------------------------------------
   # Specific checks for 'vlan' interfaces
   #------------------------------------------------------------------#}
  {%- elif interface['type'] == 'vlan' -%}

    {#- Validate vlan index -#}
    {%-   if interface['vlan']['index'] is sameas None -%}
      {{ validation_results.err_msgs.append(
        "Interface " ~ interface['uid'] ~ ": missing vlan index") }}
      {#- Interface is now invalid -#}
      {{ validation_results.update({"is_valid": false}) }}
    {%- elif interface['vlan']['index'] | int < 0 -%}
      {{ validation_results.err_msgs.append(
        "Interface " ~ interface['uid'] ~ ": vlan index < 0") }}
      {#- Interface is now invalid -#}
      {{ validation_results.update({"is_valid": false}) }}
    {%- elif interface['vlan']['index'] | int > 4096 -%}
      {{ validation_results.err_msgs.append(
        "Interface " ~ interface['uid'] ~ ": vlan index > 2048") }}
      {#- Interface is now invalid -#}
      {{ validation_results.update({"is_valid": false}) }}
    {%- endif -%}

    {#- Validate parent interface -#}
    {%- set parent_interface = interface['vlan']['parent']-%}
    {%- if parent_interface is sameas None -%}
      {{ validation_results.err_msgs.append(
        "Interface " ~ interface['uid'] ~ ": no parent interface") }}
      {#- Interface is now invalid -#}
      {{ validation_results.update({"is_valid": false}) }}
    {%- elif parent_interface is not string -%}
      {{ validation_results.err_msgs.append(
        "Interface " ~ interface['uid'] ~
        ": invalid parent interface") }}
      {#- Interface is now invalid -#}
      {{ validation_results.update({"is_valid": false}) }}
    {%- endif -%}

  {#--------------------------------------------------------------------
   # Unknown interface type
   #------------------------------------------------------------------#}
  {%- else -%}
    {{ validation_results.err_msgs.append(
      "Interface " ~ interface['uid'] ~ ": Invalid interface type") }}
    {#- Interface is now invalid -#}
    {{ validation_results.update({"is_valid": false}) }}
  {%- endif -%}

  {#--------------------------------------------------------------------
   # Ethernet checks
   #------------------------------------------------------------------#}
  {#- Validate hardware addresses -#}
  {%- if interface['ethernet']['address'] is not sameas None -%}
    {%- if not interface['ethernet']['address'] | hwaddr -%}
      {{ validation_results.err_msgs.append(
        "Interface " ~ interface['uid'] ~
        ": invalid hardware address") }}
      {#- Interface is now invalid -#}
      {{ validation_results.update({"is_valid": false}) }}
    {%- endif -%}
  {%- endif -%}

  {#--------------------------------------------------------------------
   # IPv4 checks
   #------------------------------------------------------------------#}
  {#- Validate static addresses -#}
  {%- if interface['inet4']['static'] -%}
    {%- for alias in interface['inet4']['static'] -%}

      {#- Validate static address -#}
      {%- if not 'address' in alias or not 'length' in alias -%}
        {{ validation_results.err_msgs.append(
          "Interface " ~ interface['uid'] ~
          ": incomplete static address definition") }}
        {#- Interface is now invalid -#}
        {{ validation_results.update({"is_valid": false}) }}
      {%- else -%}
        {%- set alias_host = alias['address'] ~'/'~ alias['length'] -%}
        {%- if not alias_host | ipv4('host/prefix') -%}
          {{ validation_results.err_msgs.append(
            "Interface " ~ interface['uid'] ~
            ": invalid static address") }}
          {#- Interface is now invalid -#}
          {{ validation_results.update({"is_valid": false}) }}
        {%- else -%}

          {#- Validate broadcast address -#}
          {%- if 'broadcast' in alias and
             not alias['broadcast'] | ipv4 -%}
            {{ validation_results.err_msgs.append(
              "Interface " ~ interface['uid'] ~
              ": invalid broadcast address") }}
            {#- Interface is now invalid -#}
            {{ validation_results.update({"is_valid": false}) }}
          {%- endif -%}

          {#- Validate static gateway -#}
          {%- if 'gateway' in alias
             and 'address' in alias['gateway'] -%}
            {%- if not alias['gateway']['address'] | ipaddr(alias_host) -%}
              {{ validation_results.err_msgs.append(
                "Interface " ~ interface['uid'] ~
                ": invalid default gateway address") }}
              {#- Interface is now invalid -#}
              {{ validation_results.update({"is_valid": false}) }}
            {%- endif -%}
          {%- endif -%}
        {%- endif -%}
      {%- endif -%}
    {%- endfor -%}
  {%- endif -%}

  {#--------------------------------------------------------------------
   # IPv6 checks
   #------------------------------------------------------------------#}
  {#- Validate static addresses -#}
  {%- if interface['inet6']['static'] -%}
    {%- for alias in interface['inet6']['static'] -%}
      {#- Validate static address -#}
      {%- if not 'address' in alias or not 'length' in alias -%}
        {{ validation_results.err_msgs.append(
          "Interface " ~ interface['uid'] ~
          ": incomplete static address definition") }}
        {#- Interface is now invalid -#}
        {{ validation_results.update({"is_valid": false}) }}
      {%- else -%}
        {%- set alias_host = alias['address'] ~'/'~ alias['length'] -%}
        {%- if not alias_host | ipv6('host/prefix') -%}
          {{ validation_results.err_msgs.append(
            "Interface " ~ interface['uid'] ~
            ": invalid static address") }}
          {#- Interface is now invalid -#}
          {{ validation_results.update({"is_valid": false}) }}
        {%- else -%}
          {#- Validate static gateway -#}
          {%- if 'gateway' in alias and 'address' in alias['gateway'] -%}
            {%- if not alias['gateway']['address'] | ipaddr(alias_host)-%}
              {{ validation_results.err_msgs.append(
                "Interface " ~ interface['uid'] ~
                ": invalid default gateway address") }}
              {#- Interface is now invalid -#}
              {{ validation_results.update({"is_valid": false}) }}
            {%- endif -%}
          {%- endif -%}
        {%- endif -%}
      {%- endif -%}
    {%- endfor -%}
  {%- endif -%}

  {#--------------------------------------------------------------------
   # Miscellaneous checks
   #------------------------------------------------------------------#}
  {#- If BOOTP is enabled and a static server address is supplied,
   #  it must be a valid IPv4 address.
  -#}
  {%- if  interface['inet4']['bootp']['enabled'] and
          interface['inet4']['bootp']['server']  and
      not interface['inet4']['bootp']['server'] | ipv4
  -%}
    {{ validation_results.err_msgs.append(
      "Interface " ~ interface['uid'] ~
      ": invalid BOOTP server address") }}
    {#- Interface is now invalid -#}
    {{ validation_results.update({"is_valid": false}) }}
  {%- endif -%}

  {#- Return validation results -#}
  {{ validation_results | to_json }}
{%- endmacro -%}
